#include <nemo/djbio.h>
#include <nemo/error.h>
#include <nemo/djbiofd.h>
#include <nemo/getln.h>
#include <nemo/exit.h>
#include <nemo/macro_unused.h>

#include "mess822.h"
#include "die.h"

static stralloc line = STRALLOC;
static unsigned int match = 0;

int main(int argc __UNUSED__, char **argv)
{
  PROGRAM = argv[0];
  for (;;) {
    if (getln(djbiofd_insmall, &line, &match, '\n') < 0) {
     if (errno == error_nomem) die_nomem();
     die_read("input");
    }
    stralloc_trim(&line, "\r\n", 2);
    if (!stralloc_append(&line, "\n")) die_nomem();
    if (!mess822_ok(&line)) break;
    djbio_putsa(djbiofd_outsmall, &line);
    if (!match) break;
  }
  djbio_flush(djbiofd_outsmall);
  _exit(0);
}
