#include "mess822.h"

unsigned int mess822_addrlist_erase(register mess822_addrlist *addrlist)
{
  register unsigned int i;
  register unsigned int len;

  if (!mess822_addrlist_ready(addrlist, 1)) return 0;

  len = addrlist->len;
  for (i = 0; i < len; ++i) {
    if (!stralloc_erase(&(addrlist->ad[i].data))) return 0;
    addrlist->ad[i].type = ' ';
  }
  addrlist->len = 0;
  return 1;
}
