#include <nemo/alloc.h>

#include "mess822.h"

#define BASE 30

#define	DATA_SIZE sizeof(mess822_addrdata)

static void init_data(register mess822_addrdata v[], register unsigned int i, register unsigned int n)
{
  while (i < n) {
    stralloc_init(&v[i].data);
    v[i].type = ' ';
    i++;
  }
}

unsigned int mess822_addrlist_realloc(register mess822_addrlist *al, register unsigned int n)
{
  register unsigned int i;
  i = al->a;
  al->a = BASE + n + (n >> 3);
  if (alloc_re((void**)&(al->ad), i * DATA_SIZE, al->a * DATA_SIZE)) {
    init_data(al->ad, i, al->a);
    return 1;
  }
  al->a = i;
  return 0;
}

unsigned int mess822_addrlist_alloc(register mess822_addrlist *al, register unsigned int n)
{
  al->len = 0;
  al->a = BASE + n + (n >> 3);
  if ((al->ad = (mess822_addrdata*)alloc(al->a * DATA_SIZE))) {
    init_data(al->ad, 0, al->a);
    return 1;
  }
  return 0;
}
