#include "mess822.h"

unsigned int mess822_content_field(stralloc *rvalue, sa_vector *keys, sa_vector *values, const stralloc *in)
{
  if (!stralloc_erase(rvalue)) return 0;

  if (!mess822_key_value_pairs(keys, values, in)) return 0;

  if (keys->len) {
    if (!stralloc_copy(rvalue, &keys->va[0])) return 0;
    sa_vector_remove(keys, 0, 1);
    sa_vector_remove(values, 0, 1);
  }

  return 1;
}
