#include "mess822.h"

unsigned int mess822_encode_data(stralloc *out, const char *buf, unsigned int len, const char *pre, const char *post)
{
  char ch;
  if (!stralloc_cats(out, pre)) return 0;
  while (len--) {
    ch = *buf++;
    if (ch == '\n') ch = '\0';
    if ((ch == '\0') || (ch == '\r') || (ch == '"') || (ch == '\\') || (ch == '[') || (ch == ']')) {
      if (!stralloc_append(out, "\\")) return 0;
    }
    if (!stralloc_append(out, &ch)) return 0;
  }
  if (!stralloc_cats(out, post)) return 0;
  return 1;
}
